(* Definition of CPS transformation *)

Require Import Coq.Lists.List.
Require Import "Variable".
Require Import SourceLang.
Require Import CpsLang.


Open Scope ctype_scope.


Fixpoint cps_term (t : sterm) : cterm :=
  let xk := fresh (fvars_in_sterm t) in
  ct_abs xk
  match t with
  | st_fvar x1 =>
      ct_app (ct_fvar xk) (ct_fvar x1)
  | st_unit =>
      ct_app (ct_fvar xk) ct_unit
  | st_abs x1 t1 =>
      ct_app (ct_fvar xk) (ct_abs x1 (cps_term t1))
  | st_app tf ta =>
      let xf := fresh (xk :: fvars_in_sterm ta) in
      let xa := fresh (xf :: xk :: nil) in
      ct_app (cps_term tf) (ct_abs xf
      (ct_app (cps_term ta) (ct_abs xa
       (ct_app (ct_app (ct_fvar xf) (ct_fvar xa)) (ct_fvar xk)))))
  end.


Fixpoint cps_type (T : stype) : ctype :=
  match T with
  | sy_unit =>
      cy_unit
  | sy_func TA TR =>
      cy_func (cps_type TA) (! ! cps_type TR)
  end.
